/* o_empty.c - Remove empty subtrees - Don Yang / Dave Newquist / John Rapp

   07/26/01
                                                                           */

#include<stdio.h>
#include"token.h"
#include"tree.h"


/***************************************************************** o_empty */
int o_empty(Node **node)
{
   int modified;

   modified = 0;
   while( *node )
   {
      if( (*node)->token->tagtype )
      {
         /* Tag */
         if( (*node)->tree )
         {
            /* Parse nonempty subtree */
            modified |= o_empty(&((*node)->tree));
         }
         else
         {
            /* Empty subtree, remove node */
            DeleteNode(node);
            modified = 1;
            continue;
         }
      }
      node = &((*node)->next);
   }

   return modified;

} /* o_empty() */
